Ulfius: src/yuarel.c File Reference

Ulfius HTTP Framework for REST Applications in C

Typedefs | Functions
yuarel.c File Reference
`#include <stdio.h>`
`#include <stdlib.h>`
`#include <string.h>`
`#include "yuarel.h"`
Include dependency graph for yuarel.c:

## Typedefs
typedef int | make_iso_compilers_happy

## Functions
int | yuarel_parse (struct yuarel *url, char *u)
int | yuarel_split_path (char *path, char **parts, int max_parts)
int | yuarel_parse_query (char *query, char delimiter, struct yuarel_param *params, int max_params)

## Typedef Documentation

## ◆ make_iso_compilers_happy

typedef int make_iso_compilers_happy

## Function Documentation

## ◆ yuarel_parse()

int yuarel_parse | ( | struct yuarel * | url,
|  | char * | u )

Parse a URL string to a struct.

url: pointer to the struct where to store the parsed URL parts. u: the string containing the URL to be parsed.

Returns 0 on success, otherwise -1.

## ◆ yuarel_split_path()

int yuarel_split_path | ( | char * | path,
|  | char ** | parts,
|  | int | max_parts )

Split a path into several strings.

No data is copied, the slashed are used as null terminators and then pointers to each path part will be stored in **parts. Double slashes will be treated as one.

path: the path to split. parts: a pointer to an array of (char *) where to store the result. max_parts: max number of parts to parse.

## ◆ yuarel_parse_query()

int yuarel_parse_query | ( | char * | query,
|  | char | delimiter,
|  | struct yuarel_param * | params,
|  | int | max_params )

Parse a query string into a key/value struct.

The query string should be a null terminated string of parameters separated by a delimiter. Each parameter are checked for the equal sign character. If it appears in the parameter, it will be used as a null terminator and the part that comes after it will be the value of the parameter.

No data are copied, the equal sign and delimiters are used as null terminators and then pointers to each parameter key and value will be stored in the yuarel_param struct.

*query: the query string to parse. delimiter: the character that separates the key/value pairs from eachother. *params: an array of (struct yuarel_param) where to store the result. max_values: max number of parameters to parse.

Returns the number of parsed items. -1 on error.